#include <mrw/stacktrace.hpp>
#include <cppunit/TestFixture.h>
#include <cppunit/ui/text/TestRunner.h>
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/extensions/TestFactoryRegistry.h>

namespace mrw {
  class StackTraceTest: public CppUnit::TestFixture { 
  public:
    /// test if symbols are correctely evaluated
    void StackTrace() {
      mrw::StackTrace::createSymtable();
      mrw::StackTrace s; int l(__LINE__); std::string f(__FILE__);
      std::stringstream ss;
      ss<<f<<':'<<l;
      std::string st(s);
      int pos(st.find(ss.str()));
      CPPUNIT_ASSERT(pos<st.size());
      CPPUNIT_ASSERT(st.find("mrw::StackTraceTest::StackTrace()", pos)
                     < st.size());
    }
    CPPUNIT_TEST_SUITE(StackTraceTest);
    CPPUNIT_TEST(StackTrace);
    CPPUNIT_TEST_SUITE_END();
  };
  CPPUNIT_TEST_SUITE_REGISTRATION(StackTraceTest);
}

int main() {
  CppUnit::TextUi::TestRunner runner;
  runner.addTest(CppUnit::TestFactoryRegistry::getRegistry().makeTest());
  return runner.run() ? 0 : 1;
}
